# sample_two.py

import wx

# class MyPanel
# class MyFrame
# class MyApp

#---------------------------------------------------------------------------

class MyPanel(wx.Panel):
    """
    Thanks to Alain Delgrange.
    """
    def __init__(self, parent):
        wx.Window.__init__(self, parent, -1)

        #------------

        # Attributes.
        self.parent = parent

        #------------

        # Simplified init method.
        self.SetBackground()
        self.BindEvents()

    #-----------------------------------------------------------------------

    def SetBackground(self):
        """
        ...
        """

        self.SetBackgroundStyle(wx.BG_STYLE_CUSTOM)


    def BindEvents(self):
        """
        Bind all the events related to my dialog.
        """

        # Bind a event to an events handler.
        self.Bind(wx.EVT_SIZE, self.OnResize)
        self.Bind(wx.EVT_PAINT, self.OnPaint)


    def OnResize(self, event):
        """
        ...
        """

        self.Refresh()

        
    def OnPaint(self, event=None):
        """
        ...
        """

        width, height = self.GetClientSize()

        dc = wx.BufferedPaintDC(self)
        dc.GradientFillLinear((0,
                               0,
                               int(width/2),
                               int(height)),
                               wx.YELLOW,
                               wx.SystemSettings.GetColour(wx.SYS_COLOUR_MENU),
                               wx.WEST)

        dc.GradientFillLinear((int(width/2),
                               0,
                               int(width/2),
                               int(height)),
                               wx.YELLOW,
                               wx.SystemSettings.GetColour(wx.SYS_COLOUR_MENU),
                               wx.EAST)

        label = "Hello World !"        
        wt, ht = self.GetTextExtent(label)
        dc.SetFont(wx.Font(18, wx.SWISS, wx.NORMAL, wx.BOLD, False, "Tahoma"))        
        dc.SetTextForeground("#b4b4b4")
        dc.DrawText(label, int(width/2-(wt+8)), int(height/2-(ht)))

#---------------------------------------------------------------------------

class MyFrame(wx.Frame):
    """
    Thanks to Alain Delgrange.
    """
    def __init__(self):
        style = (wx.DEFAULT_FRAME_STYLE)
        wx.Frame.__init__(self,
                          None,
                          -1,
                          title="",
                          size=(380, 130),
                          style=style)

        #------------

        # Simplified init method.
        self.SetProperties()
        self.CreateCtrls()

    #-----------------------------------------------------------------------

    def SetProperties(self):
        """
        Set the frame properties (title, icon...).
        """

        self.SetTitle("Text with transparent background - 2")

        #------------

        frameicon = wx.Icon("Icons/wxWidgets.ico")
        self.SetIcon(frameicon)
        

    def CreateCtrls(self):
        """
        Make widgets for my frame.
        """

        self.pnl = MyPanel(self)

#---------------------------------------------------------------------------

class MyApp(wx.App):
    """
    ...
    """
    def OnInit(self):

        #------------

        frame = MyFrame()
        self.SetTopWindow(frame)
        frame.Show(True)

        return True

#---------------------------------------------------------------------------

def main():
    app = MyApp(False)
    app.MainLoop()

#---------------------------------------------------------------------------

if __name__ == "__main__" :
    main()
